package gssim.db.config;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

public class MySQLConfig extends Config {

	/** Constructor to fill db data from properties file */
	public MySQLConfig(String propertiesPath) throws FileNotFoundException,
			IOException {
		super(propertiesPath);
		
		initOtherConfigParameters();
	}

	/** Constructor to fill db data from encrypted properties file */
	public MySQLConfig(String encryptedPropertiesPath, String keyPath)
			throws FileNotFoundException, IOException {
		super(encryptedPropertiesPath, keyPath);
		
		initOtherConfigParameters();
		
		System.out.println(user);
		System.out.println(password);
		System.out.println(db);
	}

	public MySQLConfig() {
		user = "root";
		password = null;
		db = "localhost:3306/gssim_results";
		
		initOtherConfigParameters();
	}

	private void initOtherConfigParameters() {
		statsFile = "Stats_Simulation 1_Simulation.txt";
		jobsFile = "Stats_Simulation 1_Jobs.txt";
		tasksFile = "Stats_Simulation 1_Raw_Tasks.txt";
		resourcesFile = "Stats_Simulation 1_Raw_Resources.txt";
		energyFile = "Stats_Simulation 1_Energy.txt";
		resourceLoadFile = "Stats_Simulation 1_Resource_Load.txt";
		accumulatedResourcesFile = "Stats_Simulation 1_Accumulated_Resources.txt";
		networkFile = "Stats_Simulation 1_Network.txt";
		propertiesFile = "experiment.properties";

		extractDirectoryPath = null;

		propertiesIgnoreKeys = new ArrayList<String>();

		propertiesIgnoreKeys.add("createstatistics.formatoutput");
		propertiesIgnoreKeys.add("printhistory");
		propertiesIgnoreKeys.add("readscenario.workloadfilename");
		propertiesIgnoreKeys.add("readscenario.inputfolder");
		propertiesIgnoreKeys.add("resdesc");
		propertiesIgnoreKeys.add("stats.outputfolder");
		propertiesIgnoreKeys.add("user.dn");
		propertiesIgnoreKeys.add("experiment.id");
	}

}
