package gssim.gssimstudio.db.dao.data {
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 * @author Jarek Szymczak
 * 
 */
[Bindable]
[RemoteClass(alias = "gssim.db.dao.data.Reservation")]
public class Reservation {

	protected var PK:int;
	protected var taskId:int;
	protected var unitId:int;
	protected var begin:Date;
	protected var end:Date;
	protected List<ReservationDetails> reservationDetails = new ArrayList<ReservationDetails>();

	public function getPK():int {
		return PK;
	}

	/**
	 * Sets the primary key in the reservation class and foreign keys in
	 * reservation details list.
	 * 
	 * @param pK
	 *            primary key
	 */
	public function setPK(pK:int):void {
		PK = pK;
		if (reservationDetails.size() > 0)
			for (ReservationDetails reservationDetail : reservationDetails) {
				reservationDetail.setFkReservationId(pK);
			}
	}

	public function getTaskId():int {
		return taskId;
	}

	public function setTaskId(taskId:int):void {
		this.taskId = taskId;
	}

	public function getUnitId():int {
		return unitId;
	}

	public function setUnitId(unitId:int):void {
		this.unitId = unitId;
	}

	public function getBegin():Date {
		return begin;
	}

	public function setBegin(begin:Date):void {
		this.begin = begin;
	}

	public function getEnd():Date {
		return end;
	}

	public function setEnd(end:Date):void {
		this.end = end;
	}

	public function addReservationDetails(reservationDetail:ReservationDetails):void {
		reservationDetails.add(reservationDetail);
	}

	/**
	 * Gets the reservation details on list.
	 * 
	 * @param accReservationDetails
	 *            the list, on which reservation details are copied (the list
	 *            should be initialized)
	 */
	public function getReservationDetailsOnList(
			List<ReservationDetails> accReservationDetails):void {
		if (accReservationDetails == null)
			return;
		for (ReservationDetails reservationDetail : reservationDetails) {
			accReservationDetails.add(reservationDetail);
		}
	}
}
}
