package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.PreferenceError;
	import gssim.gssimstudio.editor.gssim.resources.types.HostParameterType;
	import gssim.gssimstudio.editor.gssim.workload.types.PreferenceType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Class for storing computing resource
	 */
	public class ComputingResource extends Resource
	{
		/**
		 * Node Info for queueing system
		 */
		[Bindable]
		public var nodeInfo : NodeInfo
		
		/**
		 * Collection of hostParameters included with this computing resource
		 */
		[Bindable]
		public var hostParameters : ArrayCollection;
		
		/**
		 * Collection of otherParameters included with this computing resource
		 */
		[Bindable]
		public var otherParameters : ArrayCollection;
		
		[Bindable]
		public var count : Number = 1;
		
		public function ComputingResource()
		{
			hostParameters = new ArrayCollection();
			otherParameters = new ArrayCollection();
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <computingResource />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "resourceId", resourceId, true);
			var xmlMachine : XML = <machineParameters />;
			for each (var host : HostParameter in hostParameters)
			{
				xmlMachine.appendChild(host.getXML(addLabel));
			}
			for each (var other : OtherParameter in otherParameters)
			{
				xmlMachine.appendChild(other.getXML(addLabel));
			}
			xml.appendChild(xmlMachine);
			if (nodeInfo != null) xml.appendChild(nodeInfo.getXML(addLabel));
			
			return xml;
		}
		
		public override function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			/*
			var ae : AbstractError;
			for each (var param : PreferenceParameter in preferenceParameters)
			{
				if (preferenceType == null) ac.addItem(new PreferenceError("MissingPreferenceTypeError", this));
				for each (ae in param.validate()) ac.addItem(ae);
			}*/
			return ac;
		}
	}
}
