package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.PreferenceError;
	import gssim.gssimstudio.editor.gssim.resources.types.HostParameterType;
	import gssim.gssimstudio.editor.gssim.workload.types.PreferenceType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Class for storing resource host parameter
	 */
	public class HostParameter extends XMLBasicWrapper implements ValidableObject
	{
		/**
		 * Type of the host parameter
		 */
		[Bindable]
		public var hostParameterType : String;
		
		/**
		 * Value of parameter
		 */
		[Bindable]
		public var hostParameterParamValue : String;
		
		/**
		 * Collection of properties included with this host parameter
		 */
		[Bindable]
		public var properties : ArrayCollection;
		
		public function HostParameter()
		{
			hostParameterType = HostParameterType.cpucount;
			properties = new ArrayCollection();
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <hostParameter />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "name", hostParameterType, true);
			appendChildWithText(xml, "<paramValue/>", hostParameterParamValue, true, addLabel); 
			for each (var param : Property in properties)
			{
				xml.appendChild(param.getXML(addLabel));
			}
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			/*
			var ae : AbstractError;
			for each (var param : PreferenceParameter in preferenceParameters)
			{
				if (preferenceType == null) ac.addItem(new PreferenceError("MissingPreferenceTypeError", this));
				for each (ae in param.validate()) ac.addItem(ae);
			}*/
			return ac;
		}
	}
}
