package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.PreferenceError;
	import gssim.gssimstudio.editor.gssim.resources.types.PropertyType;
	import gssim.gssimstudio.editor.gssim.workload.types.PreferenceType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Class for storing resource host parameter property
	 */
	public class Property extends XMLBasicWrapper implements ValidableObject
	{
		/**
		 * Type of the property
		 */
		[Bindable]
		public var propertyType : String;
		
		/**
		 * Value of property
		 */
		[Bindable]
		public var propertyValue : String;
				
		public function Property()
		{
			propertyType = PropertyType.corecount;
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <property />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "name", propertyType, true);
			appendChildWithText(xml, "<value/>", propertyValue, true, addLabel);
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			/*
			var ae : AbstractError;
			for each (var param : PreferenceParameter in preferenceParameters)
			{
				if (preferenceType == null) ac.addItem(new PreferenceError("MissingPreferenceTypeError", this));
				for each (ae in param.validate()) ac.addItem(ae);
			}*/
			return ac;
		}
	}
}
