package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.PreferenceError;
	import gssim.gssimstudio.editor.gssim.workload.types.PreferenceType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Class for storing QueueResource
	 */
	public class QueueResource extends Resource
	{
		/**
		 * Collection of queueParameters included with this queue resource
		 */
		[Bindable]
		public var queueParameters : ArrayCollection;
		
		public function QueueResource()
		{
			queueParameters = new ArrayCollection();
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <queueResource />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "resourceId", resourceId, true);
			var xmlQueue : XML = <queueParameters />;
			for each (var param : QueueParameter in queueParameters)
			{
				xmlQueue.appendChild(param.getXML(addLabel));
			}
			xml.appendChild(xmlQueue);
			
			return xml;
		}
		
		public override function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			/*
			var ae : AbstractError;
			for each (var param : PreferenceParameter in preferenceParameters)
			{
				if (preferenceType == null) ac.addItem(new PreferenceError("MissingPreferenceTypeError", this));
				for each (ae in param.validate()) ac.addItem(ae);
			}*/
			return ac;
		}
	}
}
