package gssim.gssimstudio.editor.gssim.resources
{
	import gssim.gssimstudio.editor.gssim.errors.AbstractError;
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.errors.workload.ParametersError;
	import gssim.gssimstudio.editor.gssim.errors.workload.RandParamsByTagError;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;
	
	/**
	 * Stores workload configuration properties
	 */
	public class ResourcesBasic extends XMLBasicWrapper implements ValidableObject
	{
		/**
		 * Array collection with stored resources
		 */
		[Bindable]
		public var resources : ArrayCollection;
		
		/**
		 * Array collection with stored resources
		 */
		[Bindable]
		public var queues : ArrayCollection;
		
		public function ResourcesBasic()
		{
			resources = new ArrayCollection();
			queues = new ArrayCollection();
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = <hostParameters />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance", false);
			
			var xmlRes : XML = <resources />;
			for each (var res2 : Resource in queues)
			{
				xmlRes.appendChild(res2.getXML(addLabel));
			}
			for each (var res : Resource in resources)
			{
				xmlRes.appendChild(res.getXML(addLabel));
			}
			xml.appendChild(xmlRes);
			//for debug only
			//trace(xml.toXMLString());
			return xml;
		}

		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			var ae : AbstractError;
			

			/*
			//check for reference id errors
			var referencing : ArrayCollection = new ArrayCollection();
			var listOfIds : ArrayCollection = new ArrayCollection();
			for each (var rand : Object in properties)
			{
				if (rand is RandParams)
				{
					addToLists(listOfIds, referencing, rand as RandParams, ac);
				}
			}
			for each (var cpar : ComputingResourceHostParameter in CRHP)
			{
				addToLists(listOfIds, referencing, cpar.value, ac);
				addToLists(listOfIds, referencing, cpar.range.min, ac);
				addToLists(listOfIds, referencing, cpar.range.max, ac);
			}
			for each (var r : RandParams in referencing)
			{
				if (!listOfIds.contains(r.params.RefElementId)) ac.addItem(new ParametersError("UnknownReferenceError", r.params));
				else if (r.params.RefElementId == r.params.Id) ac.addItem(new ParametersError("SelfReferenceError", r.params));
				//TODO: detect complex cycle references
			}
			*/
			
			return ac;
		}
		
		/**
		 * Add given id to lists for id reference errors validation
		 */
		/*
		private function addToLists(ids : ArrayCollection, refs : ArrayCollection, rand : RandParams, errorList : ArrayCollection) : void
		{
			if (rand == null) return;
			if (rand.params.Id != null && rand.params.Id != "")
			{
				if (ids.contains(rand.params.Id)) errorList.addItem(new ParametersError("DoubleIDError", rand.params));
				else ids.addItem(rand.params.Id);
			}
			if (rand.params.RefElementId != null && rand.params.RefElementId != "") refs.addItem(rand);
		}*/
	}
}
