package gssim.gssimstudio.editor.gssim.resources.file
{
	import flash.net.FileReference;
	
	import gssim.gssimstudio.editor.gssim.editors.topology.ObjectCanvas;
	import gssim.gssimstudio.editor.gssim.resources.ComputingResource;
	import gssim.gssimstudio.editor.gssim.resources.NodeInfo;
	import gssim.gssimstudio.editor.gssim.resources.Resource;
	import gssim.gssimstudio.editor.gssim.resources.ResourcesBasic;
	import gssim.gssimstudio.editor.gssim.topology.GenderObject;
	import gssim.gssimstudio.editor.gssim.topology.ResourceObject;
	
	/**
	 * Writes network topology to file
	 */
	public class resourcesWriter
	{
		private var fref : FileReference;
		private var basic : ResourcesBasic;
		
		public function resourcesWriter()
		{
			basic = new ResourcesBasic();
			for each (var node : GenderObject in ObjectCanvas.graph.nodes)
			{
				if (node is ResourceObject)
				{
					var res : ResourceObject = node as ResourceObject;
					if (res.cluster)
					{
						basic.resources.addItem(res.frontend);
						basic.queues.addItem(res.queue);
						var info : NodeInfo = new NodeInfo();
						info.frontendId = res.frontend.resourceId;
						info.queueId = res.queue.resourceId;
						for each (var clusteredRes : ComputingResource in res.clusteredResources)
						{
							clusteredRes.nodeInfo = info;
							if (clusteredRes.count > 1)
							{
								for (var i : Number = 0; i < clusteredRes.count; i++)
								{
									var cRes : ComputingResource = new ComputingResource();
									cRes.resourceId = clusteredRes.resourceId + "_" + i.toString();
									cRes.hostParameters = clusteredRes.hostParameters;
									cRes.otherParameters = clusteredRes.otherParameters;
									cRes.nodeInfo = info;
									basic.resources.addItem(cRes);
								}
							}
							else
								basic.resources.addItem(clusteredRes);
						}
					}
					else
						basic.resources.addItem(res.frontend);
				}
			}
		}
		
		public function saveToFile() : void
		{
			//this doesnt work under IE
			fref = new FileReference();
			fref.save(getXMLString());
		}
		
		public function getXMLString() : String
		{
			return basic.toXMLString();
		}
	}
}