package gssim.gssimstudio.editor.gssim.topology
{
	import com.degrafa.GeometryGroup;
	import com.degrafa.geometry.Line;
	import com.degrafa.paint.SolidStroke;
	
	/**
	 * A standard link between two points
	 */
	public class Linker extends GeometryGroup
	{
		private var _x1 : Number;
		private var _y1 : Number;
		private var _x2 : Number;
		private var _y2 : Number;
		protected var line : Line;
		public var geometryGroup : GeometryGroup;
		
		
		public function get x1() : Number { return _x1; }
		public function set x1(value : Number) : void { _x1 = value; }
		public function get y1() : Number { return _y1; }
		public function set y1(value : Number) : void { _y1 = value; }
		public function get x2() : Number { return _x2; }
		public function set x2(value : Number) : void { _x2 = value; }
		public function get y2() : Number { return _y2; }
		public function set y2(value : Number) : void { _y2 = value; }
		
		public function Linker(x1 : Number, y1 : Number, x2 : Number, y2: Number)
		{
			_x1 = x1;
			_y1 = y1;
			_x2 = x2;
			_y2 = y2;
			
			line = new Line();
			geometryGroup = new GeometryGroup();
			
			var _lineStroke : SolidStroke = new SolidStroke();
            _lineStroke.color = "Gray";
            _lineStroke.weight = 5;
            line.stroke = _lineStroke;
			
			this.geometryCollection.addItem(line);
			
			refresh();
		}
		
		/**
		 * Redraw line
		 */
		public function refresh() : void
		{
			line.x = _x1;
			line.y = _y1;
			line.x1 = _x2;
			line.y1 = _y2;
			this.draw(null,null);
		}

	}
}
