package gssim.gssimstudio.editor.gssim.topology.layouts
{
	
	import gssim.gssimstudio.editor.flare.vis.Visualization;
	import gssim.gssimstudio.editor.flare.vis.data.Data;
	import gssim.gssimstudio.editor.flare.vis.data.NodeSprite;
	import gssim.gssimstudio.editor.flare.vis.operator.layout.ForceDirectedLayout;
	
	import gssim.gssimstudio.editor.gssim.topology.Graph;
	import gssim.gssimstudio.editor.gssim.topology.GraphItem;

	/**
	 * Force-directed layout imported from Flare
	 */
	public class gssimForceDirectedLayout implements ILayout
	{
		public function gssimForceDirectedLayout()
		{
			;
		}
		
		public function isStatic() : Boolean
		{
			return true;
		}

		public function doLayout(graph:Graph) : void
		{
			var data : Data = new Data();
			var nodes : Object = new Object();
			for each (var item : GraphItem in graph.nodes)
			{
				var node : NodeSprite = data.addNode(item);
				nodes[item.id] = node;
				node.x = item.x;
				node.y = item.y;
			}
			for each (var first : GraphItem in graph.nodes)
			{
				for (var neighbor : String in graph.neighbors(first.id))
				{
					data.addEdgeFor(nodes[first.id], nodes[neighbor]);
				}
			}
			var force : ForceDirectedLayout = new ForceDirectedLayout(false, 200);
			force.defaultSpringLength = 250;
			force.defaultParticleMass = 10;
			force.defaultSpringTension = 1;
			var vis : Visualization = new Visualization(data);
			vis.operators.add(force);
			vis.update();
			for (var i : Number = 0; i < data.nodes.length; i++)
			{
				var graphItem : GraphItem = data.nodes[i].data as GraphItem;
				graphItem.x = data.nodes[i].x;
				graphItem.y = data.nodes[i].y;
				graphItem.dispatchMoveAction();		
			}
		}
	}
}
