package gssim.gssimstudio.editor.gssim.topology.layouts
{
	
	import gssim.gssimstudio.editor.flare.vis.Visualization;
	import gssim.gssimstudio.editor.flare.vis.data.Data;
	import gssim.gssimstudio.editor.flare.vis.data.NodeSprite;
	import gssim.gssimstudio.editor.flare.vis.operator.layout.IndentedTreeLayout;
	
	import gssim.gssimstudio.editor.gssim.topology.Graph;
	import gssim.gssimstudio.editor.gssim.topology.GraphItem;

	/**
	 * Indent layout imported from Flare
	 */
	public class gssimIndentLayout implements ILayout
	{
		public function gssimIndentLayout()
		{
			;
		}

		public function isStatic() : Boolean
		{
			return false;
		}

		public function doLayout(graph:Graph) : void
		{
			if (!graph.hasNodes) return;
			
			var data : Data = new Data();
			var nodes : Object = new Object();
			for each (var item : GraphItem in graph.nodes)
			{
				var node : NodeSprite = data.addNode(item);
				nodes[item.id] = node;
			}
			for each (var first : GraphItem in graph.nodes)
			{
				for (var neighbor : String in graph.neighbors(first.id))
				{
					data.addEdgeFor(nodes[first.id], nodes[neighbor]);
				}
			}
			var indent : IndentedTreeLayout = new IndentedTreeLayout(100,40);
			var vis : Visualization = new Visualization(data);
			vis.operators.add(indent);
			vis.update();
			for (var i : Number = 0; i < data.nodes.length; i++)
			{
				var graphItem : GraphItem = data.nodes[i].data as GraphItem;
				graphItem.x = data.nodes[i].x;
				graphItem.y = data.nodes[i].y;
				graphItem.dispatchMoveAction();		
			}
		}
	}
}
