package gssim.gssimstudio.editor.gssim.workload
{
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;

	/**
	 * Consists of metric, value and optionally a range. Used to define dependant values
	 */
	public class ComputingResourceHostParameter extends XMLBasicWrapper implements ValidableObject
	{
		[Bindable]
		public var metric : String;
		[Bindable]
		public var value : RandParams;
		public var range : Range;
		
		public function ComputingResourceHostParameter(metric : String)
		{
			this.metric = metric;
			value = new RandParams("<value />");
			range = new Range();
		}

		public override function getXML(addLabel : Boolean):XML
		{
			var xml : XML = <ComputingResourceHostParameter />;
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addStringAttribute(xml, "metric", metric, true);
			if (value != null) xml.appendChild(value.getXML(addLabel));
			var rangeXML : XML = range.getXML(addLabel);
			if (rangeXML != null) xml.appendChild(rangeXML);
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			
			return ac;
		}
	}
}
