package gssim.gssimstudio.editor.gssim.workload
{
	import gssim.gssimstudio.editor.gssim.errors.ValidableObject;
	import gssim.gssimstudio.editor.gssim.workload.types.DistributionType;
	import gssim.gssimstudio.editor.gssim.xml.XMLBasicWrapper;
	
	import mx.collections.ArrayCollection;
	
	/**
	 * Stores basic probabilistic parameters
	 */
	public class ParameterAttributes extends XMLBasicWrapper implements ValidableObject
	{
		[Bindable]
		public var parentTagName : String = "";
		
		protected var tagName : XML = <value />;
		
		protected var properties : Object; // map id->value
		
		public static const id : String = "id";
		public static const refElementId : String = "refElementId";
		public static const expr : String = "expr";
		public static const avg : String = "avg";
		public static const stdev : String = "stdev";
		public static const min : String = "min";
		public static const max : String = "max";
		public static const seed : String = "seed";
		public static const distribution : String = "distribution";
		
		public function get Id() : String
		{
			return properties[id];
		}
		public function set Id(_value : String) : void
		{
			properties[id] = _value;
		}

		public function get RefElementId() : String
		{
			return properties[refElementId];
		}
		
		public function set RefElementId(_value : String) : void
		{
			properties[refElementId] = _value;
		}
		
		public function get Expr() : String
		{
			return properties[expr];
		}
		
		public function set Expr(_value : String) : void
		{
			properties[expr] = _value;
		}
		
		public function get Avg() : Number
		{
			return properties[avg] as Number;
		}
		
		public function set Avg(_value : Number) : void
		{
			properties[avg] = _value;
		}
		
		public function get Stdev() : Number
		{
			return properties[stdev] as Number;
		}
		
		public function set Stdev(_value : Number) : void
		{
			properties[stdev] = _value;
		}
		
		public function get Min() : Number
		{
			return properties[min] as Number;
		}
		
		public function set Min(_value : Number) : void
		{
			properties[min] = _value;
		}
		
		public function get Max() : Number
		{
			return properties[max] as Number;
		}
		
		public function set Max(_value : Number) : void
		{
			properties[max] = _value;
		}
		
		public function get Seed() : Number
		{
			return properties[seed] as Number;
		}
		
		public function set Seed(_value : Number) : void
		{
			properties[seed] = _value;
		}
		
		public function get Distribution() : String
		{
			return properties[distribution];
		}
		
		public function set Distribution(_value : String) : void
		{
			properties[distribution] = _value;
		}
		
		/**
		 * Returns property value given by name
		 */
		public function getProperty(propertyName : String) : Object
		{
			return properties[propertyName];
		}
		
		/**
		 * Sets property value given by name
		 */
		public function setProperty(propertyName : String, _value : Object) : void
		{
			properties[propertyName] = _value;
		}
		
		public function ParameterAttributes(parentTagName : String)
		{
			properties = new Object();
			Avg = NaN;
			Min = NaN;
			Max = NaN;
			Seed = NaN;
			Stdev = 1;
			Distribution = DistributionType.CONSTANT;
			this.parentTagName = parentTagName;
		}
		
		public override function getXML(addLabel : Boolean) : XML
		{
			var xml : XML = tagName.copy();
			if (addLabel) addStringAttribute(xml, "label", xml.toXMLString(), false);
			addParamsToTag(xml);
			return xml;			
		}

		/**
		 * Add all properties as attributes to given XML tag
		 */
		public function addParamsToTag(xml : XML) : XML
		{
			addStringAttribute(xml, "id", Id, false);
			addStringAttribute(xml, "refElementId", RefElementId, false);
			addStringAttribute(xml, "expr", Expr, false);
			addNumberAttribute(xml, "avg", Avg, false);
			addNumberAttribute(xml, "stdev", Stdev, false);
			addNumberAttribute(xml, "min", Min, false);
			addNumberAttribute(xml, "max", Max, false);
			addNumberAttribute(xml, "seed", Seed, false);
			addStringAttribute(xml, "distribution", Distribution, false);
			return xml;
		}
		
		public function validate() : ArrayCollection
		{
			var ac : ArrayCollection = new ArrayCollection();
			
			return ac;
		}
	}
}
