package gssim.gssimstudio.editor.script.command
{
	import flash.events.Event;
	import flash.geom.Matrix;
	
	import flexlib.mdi.containers.MDICanvas;
	
	import gssim.gssimstudio.editor.gssim.editors.topology.ObjectCanvas;
	
	/**
	 * Apply zoom to the object canvas in network editor
	 */
	public class ApplyZoomCommand implements ICommand
	{
		
		private static const MINIMUM_ZOOM_VALUE : Number = 0.4;
		private static const MAXIMUM_ZOOM_VALUE : Number = 2.0;
		
		private var objectCanvas : ObjectCanvas;
		private var delta : Number;
		private var stageX : Number;
		private var stageY : Number;
		
		public function ApplyZoomCommand(target : ObjectCanvas, delta : Number, tx : Number, ty : Number)
		{
			objectCanvas = target;
			this.delta = delta;
			stageX = tx;
			stageY = ty;
		}

		public function execute():void
		{
			var matrix : Matrix = objectCanvas.surface.transform.matrix;
			var sign : Number = 1;
			if (delta > 0) sign = 6/5;
			if (delta < 0) sign = 5/6;
			if (matrix.a * sign < MINIMUM_ZOOM_VALUE) return;
			if (matrix.a * sign > MAXIMUM_ZOOM_VALUE) return;
			objectCanvas.applyZoom(sign, stageX, stageY);
			var k : OpenMinimapWindowCommand = new OpenMinimapWindowCommand(null);
			k.scale();
			objectCanvas.validatePosition();
		}
		
		public function executeFromListener(event:Event):void
		{
			execute();
		}
	}
}
