package gssim.gssimstudio.editor.script.command
{
	import flash.events.Event;
	
	import flexlib.mdi.containers.MDICanvas;
	
	import gssim.gssimstudio.editor.gssim.editors.topology.NetworkEditorToolbox;
	import gssim.gssimstudio.editor.gssim.editors.topology.ObjectCanvas;
	
	/**
	 * Open toolbox window in network editor
	 */
	public class OpenToolboxWindowCommand implements ICommand
	{
		private static var toolboxWindow : NetworkEditorToolbox = new NetworkEditorToolbox();
		public var myContainer : MDICanvas;
		
		public function OpenToolboxWindowCommand(canvas : MDICanvas)
		{
			myContainer = canvas;
		}

		public function execute():void
		{
			if (!myContainer.hasOwnProperty(toolboxWindow.id))
			{
				var prevX : Number = toolboxWindow.x;
				var prevY : Number = toolboxWindow.y;
				myContainer.windowManager.add(toolboxWindow);
				toolboxWindow.x = prevX;
				toolboxWindow.y = prevY;
			}
		}
		
		public function executeFromListener(event : Event):void
		{
			execute();
		}
		
		/**
		 * Initialize position of the window
		 */
		public function init(target : ObjectCanvas) : void
		{
			toolboxWindow.canvas = target;
			toolboxWindow.x = toolboxWindow.originalX;
			toolboxWindow.y = toolboxWindow.originalY;
		}
		
	}
}
