package gssim.gssimstudio.editor.script.utils
{
	import mx.formatters.NumberFormatter;
	
	/**
	 * Allows conversion of date string into xsd:DateTime format and vice-versa
	 */
	public final class DateTimeUtil
	{
		/**
		 * Convert Date object into xsd:String object
		 */
		public static function convertFromDateToString(date : Date) : String
		{
			//CCYY-MM-DDThh:mm:ss
			var result : String = "";
			result += date.getFullYear().toString() + "-";
			result += displayTwoDigits(date.getMonth()+1) + "-";
			result += displayTwoDigits(date.getDate()) + "T";
			result += displayTwoDigits(date.getHours()) + ":";
			result += displayTwoDigits(date.getMinutes()) + ":";
			result += displayTwoDigits(date.getSeconds());
			return result;
		}
		
		/**
		 * Convert xsd:DateTime string into Date object
		 */
		public static function convertFromStringToDate(string : String) : Date
		{
			var date : Date = new Date();
			var dateStr : String = string.split("T")[0];
			var timeStr : String = string.split("T")[1];
			date.setFullYear(dateStr.split("-")[0], Number(dateStr.split("-")[1]) - 1, dateStr.split("-")[2]);
			date.setHours(timeStr.split(":")[0], timeStr.split(":")[1], timeStr.split(":")[2], 0);
			return date;
		}

		/**
		 * Write two digits even if the number is less than 10
		 */
		private static function displayTwoDigits(number : Number) : String
		{
			if (number < 10) return "0"+number.toString();
			return number.toString();
		}

	}
}
