package gssim.gssimstudio.flex.app.example;

import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.vinetoolkit.web.flex.blazeds.shared.utils.VineFlexUtilClass;
import org.vinetoolkit.web.portlet.spi.annotation.PortletDisplayName;
import org.vinetoolkit.role.VineRoleManager;
import org.vinetoolkit.spi.util.ServiceLog;


/**
 * Template provided by the Vine Toolkit project.
 *
 */
@BlazeDsDestination()
@PortletDisplayName(locales = {"en", "pl"}, values = {"Example from gssimstudio project", "Przykład z projektu gssimstudio"})
public class Example {

    private ServiceLog log = ServiceLog.getInstance(Example.class);

    @BlazeDsMethod(role = VineRoleManager.vineGuestRole)
    public ExampleModel doTestMethodPublished() {

        ExampleModel exampleModel = (ExampleModel) VineFlexUtilClass.getUIModel();

        log.debug("CATALINA_HOME through published method!! " + doTestMethodUnpublished());
        exampleModel.setMessage("CATALINA_HOME through published method 111 " + doTestMethodUnpublished());
        return exampleModel;

    }

    @BlazeDsMethod()
    public ExampleModel doTestMethodPublishedLoggedIn() {

        ExampleModel exampleModel = (ExampleModel) VineFlexUtilClass.getUIModel();

        exampleModel.setMessageAuthenticated("CATALINA_HOME through published method logged in 111 " + doTestMethodUnpublished());
        return exampleModel;

    }

    public String doTestMethodUnpublished() {
        return System.getenv("CATALINA_HOME");
    }

}